/*
 *  filefun.c
 *
 *  Copyright 2010 Henry Kroll III www.thenerdshow.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */
#include "main.h"
#include "xkeys.h"

char *setTitle(HWND hwnd,char *fname){
    static char appname[255],*fn;
    LoadString(GetModuleHandle(NULL), IDS_APPNAME, appname, sizeof(appname));
    if(fname[0]){
        strcat(appname," - ");
        if(!(fn=strrchr(fname,'/')))fn=strrchr(fname,'\\');
        fname=fn+1; strcat(appname,fname);
    }
    SetWindowText(hwnd,appname);
    return fname;
}


int fileFun(HWND hwnd,int what){
    
    HWND hEdit;
    hEdit = GetDlgItem(hwnd, IDC_MAIN_EDIT);
    OPENFILENAME ofn;
    static char szFileName[MAX_PATH] = "",fname[MAX_PATH];
    static char *fn=szFileName;
    FILE *f;long n;
    char *t;
    ZeroMemory(&ofn, sizeof(ofn));

    ofn.lStructSize = sizeof(ofn);
    ofn.hwndOwner = hwnd;
    ofn.lpstrFilter = "Text Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0";
    ofn.lpstrFile = szFileName;
    ofn.nMaxFile = MAX_PATH;
    ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
    ofn.lpstrDefExt = "txt";

    switch(what){
        
    case IDM_FILE_OPEN:
        
        if(GetOpenFileName(&ofn))
        {
#ifdef __WINE__
            strcpy(fname,winePath(szFileName));
            debug("Open Linux File '%s'\n",fname);
#else
            // Do something usefull with the filename stored in szFileName 
            debug("Open DOS File '%s'\n",szFileName);
            strcpy(fname,szFileName);
#endif
            if(!(f=fopen(fname,"r"))){
                MessageBoxA(NULL,"File open error","Error!",
                MB_ICONEXCLAMATION | MB_OK);
                return;
            }
            fseek(f,0L,SEEK_END);n=ftell(f);
            rewind(f);
            t=malloc(n+1);
            if(!t) ERM("Out of memory!");
            if(!(n=fread(t,1,n,f))){
                MessageBoxA(NULL,"File read error","Error!",
                MB_ICONEXCLAMATION | MB_OK);
                return;
            }
            fclose(f);
            fn=setTitle(hwnd,fname);
            SetDlgItemText(hwnd, IDC_MAIN_EDIT, t);
            free(t);

        }
        break;
        
    case IDM_FILE_SAVE:
        
        if(!fn[0]){
            fileFun(hwnd,IDM_FILE_SAVEAS);
        }
        debug("Save '%s'\n",fn);
        if(fn[0]){
            t=malloc(n=SendMessage(hEdit, WM_GETTEXTLENGTH, 0, 0)+1);
            if(!t) ERM("Out of memory!");
            GetDlgItemText(hwnd, IDC_MAIN_EDIT, t,n);
            if(!(f=fopen(fname,"w"))){
                MessageBoxA(NULL,"File save error","Error!",
                MB_ICONEXCLAMATION | MB_OK);
                return;
            }
            if(!(n=fwrite(t,1,n,f))){
                MessageBoxA(NULL,"File write error","Error!",
                MB_ICONEXCLAMATION | MB_OK);
                return;
            }
            fclose(f);
            free(t);
        }
        break;
    
    case IDM_FILE_SAVEAS:
        
        szFileName[0]=0;
        ofn.lpstrFile = szFileName;
        ofn.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;
        debug("Save as...\n");
        if(GetSaveFileName(&ofn)){
#ifdef __WINE__
            strcpy(fname,winePath(szFileName));
            debug("Save Linux File '%s'\n",fname);
#else
            strcpy(fname,szFileName);
            debug("Save DOS File '%s'\n",fname);
#endif
            fn=setTitle(hwnd,fname);
            fileFun(hwnd,IDM_FILE_SAVE);         
        }
        return;
        
    case IDM_FILE_QSAVE:
        
        n=GetWindowTextLength(hEdit);
        if(SendMessage(hEdit, EM_GETMODIFY, 0, 0)
            &&(n||fn[0])){
            n=MessageBox(NULL,"Save changes?","Unsaved Work",MB_ICONEXCLAMATION | MB_YESNOCANCEL);
            if(n==IDYES) fileFun(hwnd,IDM_FILE_SAVE);
            if(n==IDNO)fn=setTitle(hwnd,"");
        }
        return n;
        
    case IDM_FILE_NOSAVE:
        
           fn=setTitle(hwnd,"");

        break;
    }return 0;
}
