#!/bin/bash
set -e
#drop on head
if [[ whoami == root ]]; then
    echo "Do not run as root!"
fi
#set $HOME
if [[ ! -d $HOME ]]; then
    HOME=~/
fi
if [[ ! -d $HOME ]]; then
    echo 'Error: Please export $HOME=(your home directory).'
    exit 1
fi

ICONDIR=$HOME/.local/share/icons/
PROGDIR="C:\\Program Files\\Platypus"
INSTALLDIR=$(winepath "$PROGDIR")

# set $WINEPREFIX
if [[ ! -d $WINEPREFIX ]]; then
    if [[ ! -d $HOME/.wine ]]; then
        echo "WINEPREFIX not set and .wine folder doesn't exist"
        echo Install Wine and run winecfg.
        exit 1
    else # wine exists
        WINEPREFIX=$HOME/.wine
    fi
fi

if [[ ! ($1) ]]; then
install -D platypus.exe.so "${INSTALLDIR}/platypus.exe"
cp platypus_keys "$INSTALLDIR/"
cp platypus_commands "$INSTALLDIR/"
regedit platypus.reg
install -D images/platypus.png $ICONDIR
cat <<EOF>$HOME/Desktop/platypus.desktop
#!/usr/bin/env xdg-open

[Desktop Entry]
Encoding=UTF-8
Version=1.0
Type=Application
Terminal=false
Name[en_US]=Platypus
Exec=env WINEPREFIX="$WINEPREFIX" wine "${PROGDIR}\platypus.exe"
Name=Platypus
Icon=$HOME/.local/share/icons/platypus.png
Path=`winepath -u "${PROGDIR}"`
EOF
chmod +x $HOME/Desktop/platypus.desktop
echo Install successful
else
    rm "$INSTALLDIR/platypus_keys"
    rm "$INSTALLDIR/platypus_commands"
    rm "$INSTALLDIR/platypus.exe"
    rmdir "$INSTALLDIR"
    rm $ICONDIR/platypus.png
    rm $HOME/Desktop/platypus.desktop
    echo Uninstall successful
fi
exit 0
